﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Windows;
using System.IO.Ports;
using System.Threading;
using System.Windows.Forms;

namespace QCW
{
    public class RSComStruct : System.Object
    {
        public UInt16 ID;
        public Byte CMD;
        public Byte Para;
        public Byte[] RecDada = new Byte[1000];
        public UInt16 RecLength;
    };

    public class UARTCommPro
    {
        private byte[] ReceiveBuf = new byte[1000];
        private byte[] SendBuf = new byte[1000];
        private System.IO.Ports.SerialPort serialPort1;

        private ushort GetCRC(byte[] Array, int pianyi, int Len)
        {
            ushort CRCData = 0xFFFF;//set all 1;
            int IX, IY;

            if (Len <= 0) CRCData = 0;
            else
            {
                for (IX = pianyi; IX < Len + pianyi; IX++)
                {
                    CRCData = (ushort)(CRCData ^ (UInt16)(Array[IX]));
                    for (IY = 0; IY <= 7; IY++)
                        if ((CRCData & 1) != 0)
                            CRCData = (ushort)((CRCData >> 1) ^ 0xA001);
                        else
                            CRCData = (ushort)(CRCData >> 1);    //
                }

            }
            return (CRCData);
        }

        public UARTCommPro()
        {
            this.serialPort1 = new System.IO.Ports.SerialPort();
        }

        public bool UartOpen(string Uartname, int baudrate)
        {

            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
            serialPort1.PortName = Uartname;
            serialPort1.BaudRate = baudrate;
            try
            {
                serialPort1.Open();
            }
            catch (Exception ex)
            {
                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
                return false;
            } 
            return true;
        }
        public bool UartClose()
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
            return true;
        }

        public static string byteToHexStr(byte[] bytes, int len)
        {
            string returnStr = "";

            if (len == 1)
            {
                returnStr = bytes[0].ToString("X2");
                return returnStr;
            }
            else
            {
                int i = 0;
                for (i = 0; i < len - 1; i++)
                {
                    returnStr += bytes[i].ToString("X2");
                }
                returnStr += bytes[i].ToString("X2");
                returnStr += "\r";
                return returnStr;
            }
        }

        //public static string byteToHexStr(byte[] bytes, int len)
        //{
        //    string returnStr = "";

        //    if (len == 1)
        //    {
        //        returnStr = bytes[0].ToString("X2");
        //        return returnStr;
        //    }
        //    else
        //    {
        //        int i = 0;
        //        for (i = 0; i < len - 1; i++)
        //        {
        //            returnStr += bytes[i].ToString("X2");
        //            returnStr += " ";
        //        }
        //        returnStr += bytes[i].ToString("X2");
        //        returnStr += "\r";
        //        return returnStr;
        //    }
        //}


        public static byte[] ToBytes(string hexString)
        {
            string temp = hexString.Replace(" ", "");
            if(temp.Length%2==1)return(null);
            byte[] buffer = new byte[temp.Length / 2];
            for (int i = 0; i < temp.Length; i += 2)
            {
                buffer[i / 2] = (byte)Convert.ToByte(temp.Substring(i, 2), 16);
            }
            return buffer;
        }

        public int UartCmdSend(UInt16 id, byte Cmd, byte[] sendbuf, int SendLen, ref RSComStruct ttRSComStruct)
        {
            int RecLen = 0;
            int i = 0;

            ttRSComStruct.RecLength = 0;

            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0x68;
            SendBuf[i++] = (byte)(id >> 8);
            SendBuf[i++] = (byte)id;
            SendBuf[i++] = Cmd;
            SendBuf[i++] = 0X00;
            SendBuf[i++] = (byte)(SendLen >> 8);
            SendBuf[i++] = (byte)SendLen;
            Array.Copy(sendbuf, 0, SendBuf, i, SendLen);
            i += SendLen;
            ushort crcdata = GetCRC(SendBuf, 4, i - 4);
            SendBuf[i++] = (byte)(crcdata >> 8);
            SendBuf[i++] = (byte)crcdata;
            SendBuf[i++] = 0x55;

            
            try
            {
                Thread.Sleep(1);
                serialPort1.DiscardInBuffer();//清空接收缓冲区

                string sendstring = byteToHexStr(SendBuf, i);
                serialPort1.Write(sendstring);
               

                RecLen = 0;
                i = 0;
                while (true)
                {

                    Thread.Sleep(100);
                    i++;
                    if (i > 50) break;

                    if (serialPort1.BytesToRead > 0)
                    {
                        int ReceiveTemp = serialPort1.BytesToRead;
                        if (RecLen + ReceiveTemp < 800)
                        {
                            serialPort1.Read(ReceiveBuf, RecLen, serialPort1.BytesToRead);//
                            RecLen += ReceiveTemp;
                        }
                        else
                        {
                            break;
                        }
                    }
                    else  //没有数据继续送来
                    {
                        if (RecLen > 6 && ReceiveBuf[RecLen - 1] == 0x0d)
                        {
                               break;
                        }
                    }

                }
            }
            catch (Exception ex)
            {

                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
                return -1;
            }
            if (RecLen == 0)
            {
                return -1;
            }
            if (RecLen > 2 && RecLen < (ReceiveBuf.Length - 50))
            {
                byte[] ReceiveBufTemp = new byte[RecLen-1];
                Array.Copy(ReceiveBuf, ReceiveBufTemp, RecLen - 1);
                string str=System.Text.Encoding.ASCII.GetString(ReceiveBufTemp);

                byte[] RecArray = ToBytes(str);
                if (RecArray == null)
                {
                    return -1;
                }
                if (RecArray.Length > 0)
                {
                    Array.Copy(RecArray, ReceiveBuf, RecArray.Length);
                }
                else
                {
                    return -1;
                }
                RecLen = RecArray.Length;
                ushort crcvalue = GetCRC(ReceiveBuf, 4, RecLen - 7);
                ushort crcvalue2 = (ushort)((ushort)(((ushort)ReceiveBuf[RecLen - 3]) << 8) + (ushort)ReceiveBuf[RecLen - 2]);
                if (crcvalue == crcvalue2)
                {
                    ttRSComStruct.ID = ReceiveBuf[4];
                    ttRSComStruct.ID <<= 8;
                    ttRSComStruct.ID += ReceiveBuf[5];
                    ttRSComStruct.CMD = ReceiveBuf[6];
                    ttRSComStruct.Para = ReceiveBuf[7];
                    ttRSComStruct.RecLength = ReceiveBuf[8];
                    ttRSComStruct.RecLength <<= 8;
                    ttRSComStruct.RecLength += ReceiveBuf[9];
                    Array.Copy(ReceiveBuf, 10, ttRSComStruct.RecDada, 0, ttRSComStruct.RecLength);
                }
                else
                {
                    RecLen = 0;
                }
            }
            return RecLen;
        }

        public int UartCmdSend(byte[] Cmd, int sendlen, ref string recbuf, out int RecLen)
        {
            RecLen = 0;
            int i = 0;

            try
            {
                Thread.Sleep(1);
                serialPort1.DiscardInBuffer();//清空接收缓冲区

                serialPort1.Write(Cmd, 0, sendlen);

                RecLen = 0;
                i = 0;
                while (true)
                {

                    Thread.Sleep(20);
                    i++;
                    if (i > 10) break;

                    if (serialPort1.BytesToRead > 0)
                    {
                        int ReceiveTemp = serialPort1.BytesToRead;
                        if (RecLen + ReceiveTemp < 800)
                        {
                            serialPort1.Read(ReceiveBuf, RecLen, serialPort1.BytesToRead);//
                            RecLen += ReceiveTemp;
                        }
                        else
                        {
                            break;
                        }
                    }
                    else  //没有数据继续送来
                    {
                        if (RecLen > 2 && ReceiveBuf[RecLen - 1] == 0x0d)
                        {
                            ReceiveBuf[RecLen - 1] = 0x0d;
                            recbuf = System.Text.Encoding.ASCII.GetString(ReceiveBuf, 0, RecLen);
                            break;
                        }
                    }

                }
            }
            catch (Exception ex)
            {

                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
                return -1;
            }

            return RecLen;
        }



        public int UartCmdSend2(UInt16 id, byte Cmd, byte[] sendbuf, int SendLen, ref byte[] recbuf, out int RecLen, out string DispStr)
        {
            RecLen = 0;
            int i = 0;
            DispStr = null;
            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0xfe;
            SendBuf[i++] = 0x68;
            SendBuf[i++] = (byte)(id >> 8);
            SendBuf[i++] = (byte)id;
            SendBuf[i++] = Cmd;
            SendBuf[i++] = 05;
            SendBuf[i++] = (byte)(SendLen >> 8);
            SendBuf[i++] = (byte)SendLen;
            Array.Copy(sendbuf, 0, SendBuf, i, SendLen);
            i += SendLen;
            ushort crcdata = GetCRC(SendBuf, 4, i - 4);
            SendBuf[i++] = (byte)(crcdata >> 8);
            SendBuf[i++] = (byte)crcdata;
            SendBuf[i++] = 0x55;

            try
            {
                Thread.Sleep(1);
                serialPort1.DiscardInBuffer();//清空接收缓冲区

                serialPort1.Write(SendBuf, 0, i);  //发送命令
                DispStr = byteToHexStr(SendBuf, i);

                RecLen = 0;
                i = 0;
                while (true)
                {

                    Thread.Sleep(20);
                    i++;
                    if (i > 50) break;

                    if (serialPort1.BytesToRead > 0)
                    {
                        int ReceiveTemp = serialPort1.BytesToRead;
                        if (RecLen + ReceiveTemp < 800)
                        {
                            serialPort1.Read(ReceiveBuf, RecLen, serialPort1.BytesToRead);//
                            RecLen += ReceiveTemp;
                        }
                        else
                        {
                            break;
                        }
                    }
                    else  //没有数据继续送来
                    {
                        if (RecLen > 6 && ReceiveBuf[RecLen - 1] == 0x55)
                        {
                            //
                            ushort crcvalue = GetCRC(ReceiveBuf, 4, RecLen - 7);
                            ushort crcvalue2 = (ushort)((ushort)(((ushort)ReceiveBuf[RecLen - 3]) << 8) + (ushort)ReceiveBuf[RecLen - 2]);
                            if (crcvalue == crcvalue2) break;
                        }
                    }

                }
            }
            catch (Exception ex)
            {

                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
                return -1;
            }
            if (RecLen == 0)
            {
                return -1;
            }
            if (RecLen > 0 && RecLen < (ReceiveBuf.Length - 50))
            {
                ushort crcvalue = GetCRC(ReceiveBuf, 4, RecLen - 7);
                ushort crcvalue2 = (ushort)((ushort)(((ushort)ReceiveBuf[RecLen - 3]) << 8) + (ushort)ReceiveBuf[RecLen - 2]);
                if (crcvalue == crcvalue2)
                {
                    Array.Copy(ReceiveBuf, 0, recbuf, 0, RecLen);
                }
                else
                {
                    RecLen = 0;
                }
                DispStr += byteToHexStr(recbuf, RecLen);
            }
            return RecLen;
        }

        public int UartCmdRead(ref byte[] recbuf, out int RecLen, out string DispStr)
        {
            RecLen = 0;
            int i = 0;
            DispStr = null;
            try
            {
                while (true)
                {

                    Thread.Sleep(10);
                    i++;
                    if (i > 10) break;

                    if (serialPort1.BytesToRead > 0)
                    {
                        int ReceiveTemp = serialPort1.BytesToRead;
                        serialPort1.Read(ReceiveBuf, RecLen, serialPort1.BytesToRead);//
                        RecLen += ReceiveTemp;
                        i = 0;
                    }
                    else  //没有数据继续送来
                    {
                        if (RecLen > 6 && ReceiveBuf[RecLen - 1] == 0x55)
                        {
                            //
                            ushort crcvalue = GetCRC(ReceiveBuf, 4, RecLen - 7);
                            ushort crcvalue2 = (ushort)((ushort)(((ushort)ReceiveBuf[RecLen - 3]) << 8) + (ushort)ReceiveBuf[RecLen - 2]);
                            if (crcvalue == crcvalue2) break;
                        }
                    }

                }
            }
            catch (Exception ex)
            {

                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
                return -1;
            }
            if (RecLen == 0)
            {
                return -1;
            }
            if (RecLen > 0)
            {
                ushort crcvalue = GetCRC(ReceiveBuf, 4, RecLen - 7);
                ushort crcvalue2 = (ushort)((ushort)(((ushort)ReceiveBuf[RecLen - 3]) << 8) + (ushort)ReceiveBuf[RecLen - 2]);
                if (crcvalue == crcvalue2)
                {
                    Array.Copy(ReceiveBuf, 0, recbuf, 0, RecLen);
                }
                else
                {
                    RecLen = 0;
                }
                DispStr += byteToHexStr(recbuf, RecLen);
            }
            return RecLen;
        }

        public int UartCmdSendString(string Cmd, ref string recbuf)
        {
            int RecLen = 0;
            int i = 0;

            try
            {
                Thread.Sleep(1);
                serialPort1.DiscardInBuffer();//清空接收缓冲区

                serialPort1.Write(Cmd);

                RecLen = 0;
                i = 0;
                while (true)
                {

                    Thread.Sleep(100);
                    i++;
                    if (i > 10) break;

                    if (serialPort1.BytesToRead > 0)
                    {
                        int ReceiveTemp = serialPort1.BytesToRead;
                        if (RecLen + ReceiveTemp < 800)
                        {
                            serialPort1.Read(ReceiveBuf, RecLen, serialPort1.BytesToRead);//
                            RecLen += ReceiveTemp;
                        }
                        else
                        {
                            break;
                        }
                    }
                    else  //没有数据继续送来
                    {
                        if (RecLen > 2 &&( (ReceiveBuf[RecLen - 1] == 0x0d)||(ReceiveBuf[RecLen - 1] == 0x0a)))
                        {
                            ReceiveBuf[RecLen] = 0;
                            recbuf = System.Text.Encoding.ASCII.GetString(ReceiveBuf, 0, RecLen);
                            break;
                        }
                    }

                }
            }
            catch (Exception ex)
            {

                //现实异常信息给客户。  
                MessageBox.Show(ex.Message);
                return -1;
            }

            return RecLen;
        }
    }
}
